import pytest
import src.pulse
from tests.helpers.naming import apply_names
from tests.helpers.pixel import Pixel, fake_sleep

src.pulse.time.sleep = fake_sleep


@pytest.mark.parametrize(
    "set_color, time",
    apply_names('pulse', [True, True], [
        ((255, 0, 0), 0.05),
        ((0, 255, 0), 0.04),
        ((0, 0, 255), 0.03),
        ((132, 144, 72), 0.1),
    ])
)
def test_pulse(set_color, time):
    pixel = Pixel(time)
    src.pulse.pulse(pixel, set_color, time)
    color, hist = pixel.look()
    assert [
        ((0, 0, 0), 0),
        (set_color, 1),
        ((0, 0, 0), 2),
    ] == hist, "the pulse function should change color, wait, change color again, and wait again"
