import time

import pytest

log = []


def fake_sleep(t):
    global log
    log.append(t)


class Pixel:
    def __init__(self, duration):
        self.color = (0, 0, 0)
        self.history = []
        self.duration = duration

    def fill(self, color):
        global log
        self.history.append((self.color, len(log)))
        self.color = color

    def look(self):
        global log
        # Temporary copy of history
        cur_history = self.history[::]
        if self.duration >= 0:
            assert len(
                set(log)) == 1, "all sleeps need to be for the same duration"
            assert self.duration == pytest.approx(
                log[0], 0.001), "all of the sleeps need to be for the `duration` provided/calculated"
        cur_history.append((self.color, len(log)))
        log.clear()
        return self.color, cur_history
